* jme 09/08/2014 http://codes-sources.commentcamarche.net/source/28966-une-classe-pour-l-utilisation-de-la-memoire-partagee
* ce prg contient des procdures, fonctions et dfinition de classes concernant les API et
* les outils de windows.
* il est indpendant de standard_maurice.prg pour pouvoir tre inclus facilement dans un projet d'application esclave.

!* Objet : Utilisation de la mmoire partage pour la communication entre applications
!* Auteur : C.Chenavier
!* Version : 1.00 - 20/01/2005
!*
!* Exemple d'utilisation :
!*
!* oSharedMem = CREATEOBJECT("SharedMemory", "Nom_de_partage")
!* oSharedMem.Write("ceci est la chane  transfrer J. Maurice")
!*
!* Application 2 :
!* oSharedMem = CREATEOBJECT("SharedMemory", "Nom_de_partage")
!* MessageBox(oSharedMem.Read())
!*
!* Note : par dfaut le buffer est de 4Ko.
!* Pour le passer par exemple  32K faire :
!* oSharedMem = CREATEOBJECT("SharedMemory", "Nom_de_partage", 32*1024) 

**#INCLUDE c:\vfp\vfp9\foxpro.h

#DEFINE INVALID_HANDLE_VALUE  -1
#DEFINE PAGE_READWRITE        0x04     

#DEFINE SECTION_QUERY         0x0001
#DEFINE SECTION_MAP_WRITE     0x0002
#DEFINE SECTION_MAP_READ      0x0004
#DEFINE SECTION_MAP_EXECUTE   0x0008
#DEFINE SECTION_EXTEND_SIZE   0x0010

#DEFINE STANDARD_RIGHTS_REQUIRED   0x000F0000

#DEFINE SECTION_ALL_ACCESS (STANDARD_RIGHTS_REQUIRED+SECTION_QUERY+;
                            SECTION_MAP_WRITE + ;
                            SECTION_MAP_READ + ;
                            SECTION_MAP_EXECUTE + ;
                            SECTION_EXTEND_SIZE)


DEFINE CLASS SharedMemory AS CUSTOM
       
       hMapFile = 0       
       cSharedName = ''
       
       HIDDEN Buf_Size           
       Buf_Size = 4*1024

       PROCEDURE Init
           LPARAMETERS cSharedName, nSize

           LOCAL nLibs
           LOCAL ARRAY aLibs(1,3)

*SET STEP ON
           * THIS.Name = SYS(2015) jme 13/08/2014 cela perturbe thisForm.newobject !
           
           THIS.cSharedName = IIF(EMPTY(M.cSharedName), 'cchenavier', M.cSharedName)
           
           M.nLibs = ADLLS(aLibs)
           IF ASCAN(aLibs,"CreateFileMapping",1,0,1,7)=0
              DECLARE INTEGER CreateFileMapping IN kernel32 ; 
                      INTEGER hFile, ; 
                      INTEGER lpAttributes, ; 
                      INTEGER flProtect, ; 
                      LONG    dwMaximumSizeHi, ; 
                      LONG    dwMaximumSizeLo, ; 
                      STRING  lpName 

              DECLARE INTEGER OpenFileMapping IN kernel32 ; 
                      INTEGER flProtect, ; 
                      INTEGER wInherit, ; 
                      STRING  lpName 
                      
              DECLARE LONG MapViewOfFile IN kernel32 ; 
                      INTEGER hFileMappingObject, ; 
                      INTEGER dwDesiredAccess, ; 
                      LONG    dwFileOffsetHi, ; 
                      LONG    dwFileOffsetLo, ; 
                      LONG    dwNumberOfBytesToMap 

              DECLARE INTEGER UnmapViewOfFile IN kernel32; 
                      LONG lpBaseAddress 
           ENDIF
           IF ASCAN(aLibs,"CloseHandle",1,0,1,7)=0
              DECLARE INTEGER CloseHandle IN kernel32; 
                      INTEGER hObject 
           ENDIF
           IF NOT THIS.Open()
              THIS.New(M.nSize)
           ENDIF
       ENDPROC       

       FUNCTION New
           LPARAMETERS nSize
           
           IF NOT EMPTY(M.nSize)
              THIS.Buf_Size = M.nSize
           ENDIF

           THIS.hMapFile = CreateFileMapping( ;
                           INVALID_HANDLE_VALUE, ;
                           0, ;
                           PAGE_READWRITE, ;
                           0, ;
                           THIS.Buf_Size, ;  
                           THIS.cSharedName)
           
           RETURN (THIS.hMapFile > 0)

       ENDPROC

       FUNCTION Open           
           THIS.hMapFile = OpenFileMapping( ;
                           SECTION_ALL_ACCESS, ;
                           0, ; 
                           THIS.cSharedName)
            
           RETURN (THIS.hMapFile > 0)

       ENDPROC

       FUNCTION Read

           LOCAL pBuf, cString

           M.cString = ''
           IF THIS.hMapFile > 0
              pBuf = MapViewOfFile(THIS.hMapFile, ;
                                   SECTION_ALL_ACCESS, ;
                                   0, 0, THIS.Buf_Size)
              IF pBuf > 0
                 M.cString = SYS(2600, pBuf, THIS.Buf_Size)
                 UnmapViewOfFile(pBuf)
              ENDIF
           ENDIF

           RETURN M.cString
       ENDPROC

       FUNCTION Write

           LPARAMETERS cString
            
           LOCAL nStringLen, pBuf, lOK

           IF THIS.hMapFile > 0
              M.cString = M.cString + CHR(0)
              M.nStringLen = MIN(LEN(M.cString), THIS.Buf_Size)
              pBuf = MapViewOfFile(THIS.hMapFile, ;
                                   SECTION_ALL_ACCESS, ;
                                   0, 0, THIS.Buf_Size)
              IF pBuf > 0
                 SYS(2600, pBuf, M.nStringLen, M.cString)
                 UnmapViewOfFile(pBuf)
                 M.lOK = .T.
              ENDIF
           ENDIF

           RETURN M.lOK
       ENDPROC

       PROCEDURE Destroy
           
           IF THIS.hMapFile > 0
              CloseHandle(THIS.hMapFile)
           ENDIF
           
       ENDPROC

ENDDEFINE

